#include "node.hpp"

#include <vector>
#include <cmath>

/* 
Node::Node() {
    root_ = nullptr;
    parent_ = nullptr;
    particles_ = nullptr;
    nParticles_ = 0;
    depth_ = 0;
    size_ = 0;
    for (unsigned i=0; i<3; ++i) center_[i] = 0;
    localParticles_ = nullptr;
    nLocalParticles_ = 0;
    for (unsigned i=0; i<8; ++i) children_[i] = nullptr;
}
 */

Node::Node(Node* root, Node* parent, double* masses, double* particles, unsigned nParticles, unsigned depth, 
        double size, double center[3], std::vector<unsigned> localParticles, unsigned nLocalParticles) {
    parent_ = parent;
    particles_ = particles;
    nParticles_ = nParticles;

    depth_ = depth;
    size_ = size;

    for (unsigned i=0; i<3; ++i) center_[i] = center[i];

    localParticles_ = localParticles;
    nLocalParticles_ = nLocalParticles;

    mass_ = 0;
    for (unsigned i=0; i<nLocalParticles; ++i) {
        mass_ += masses_[localParticles_[i]];
    }

    // allocate children
    // check if child contains no particles, in that case set child to nullptr
    // TODO
}

Node::~Node() {
    for (unsigned i=0; i<8; ++i) {
        delete children_[i];
    }
}

Node& Node::operator=(const Node& other) {
    root_ = other.root_;
    parent_ = other.parent_;
    particles_ = other.particles_;
    nParticles_ = other.nParticles_;
    depth_ = other.depth_;
    size_ = other.size_;
    for (unsigned i=0; i<3; ++i) center_[i] = other.center_[i];
    localParticles_ = other.localParticles_;
    nLocalParticles_ = other.nLocalParticles_;
    mass_ = other.mass_;
    for (unsigned i=0; i<8; ++i) children_[i] = other.children_[i];
    return *this;
}

void Node::update() {
    // update this node
    // TODO
    // update children
    for (unsigned i=0; i<8; ++i) {
        if (children_[i] != nullptr) children_[i]->update();
    }
}

double* Node::calculateForce(unsigned particle) {
    // calculate theta
    double px = particles_[3*particle + 0];
    double py = particles_[3*particle + 1];
    double pz = particles_[3*particle + 2];
    double lambda = std::sqrt((center_[0] - px)*(center_[0] - px)
                            + (center_[1] - py)*(center_[1] - py)
                            + (center_[2] - pz)*(center_[2] - pz));
    double theta = size_/lambda;
    // if angle too large, call this function for every child. If a child is a nullptr, calculate force on particle from particles in this node
    // else calculate force on particle from particles in this node
    if (theta > theta0_) {
        // TODO
    } else {
        // TODO
    }
    return nullptr;
}